#ifndef __CGLMETASEQ_H
#define __CGLMETASEQ_H
/*
^ZRt@Ci*.mqoj\NX
@ǂݍ݂cGLMetaseqParentNXłB

EŒ̋@\ĂȂłB

gp@
E
PjcGLMetaseqParentNX쐬
QjcGLMetaseqParent::makeGLMetaseq\bhgcGLMetaseqNX쐬

E`@
PjcGLMetaseq::render\bhĂяoΕ`悳܂B
NintendoDS̏ꍇF}eAݒĂ̂ŁA
@glPolyFmt(xxxx | POLY_FORMT_LIGHTx);
@glLight(x,...);
@̗lȌݒȂƕ\ȂƎv܂B

ǂݍ񂾃^ZRt@C̍őlAŏl͈ȉ̕@Ŏo܂B
	const GLfloat *min = (cGLMetaseqNX).getMinPoint() ;
	const GLfloat *max = (cGLMetaseqNX).getMaxPoint() ;
	min(max)[0]=x@[1]=y  [2]=z
NintendoDS̏ꍇF_W1.3.12Œ菬_Ȃ̂
@@-8.0`8.0͈̔͂ɓǂݍݎɕϊ܂B

gpFARToolKitɂă^ZRt@C̑}[J_ɒuꍇ
	const GLfloat *min = (cGLMetaseqNX).getMinPoint() ;
	glTranslatef(0,0,min[2]*(-1)) ;
	(cGLMetaseqNX).render() ;



^ZRtH[}bg͂B
http://www.metaseq.net/metaseq/format.html

code by kei

*/
#include <nds.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fat.h>
#include "texturePool_nds.h"
#include <vector>
#include "ndsgl.h"


class cGLMetaseq
{
private :
	friend class cGLMetaseqParent;

	//\p
	typedef struct {
		bool			isValidMaterialInfo;// }eA̗L/
		bool			isUseTexture;		// eNX`̗LFUSE_TEXTURE / NOUSE_TEXTURE
		int				matnum ;			// MQOt@Cł̃}eAԍ
		GLuint			texture_id;			// eNX`̖O(OpenGL)
		GLfloat			color[4];			// Fz (r, g, b, a)
		GLfloat			alpha ;
		rgb				difrgb ;			// gU
		rgb				ambrgb ;			// ͌
		rgb				emirgb ;			// ȏƖ
		rgb				spcrgb ;			// ˌ
		rgb				powrgb ;			// ˌ̋
		u16				calllist3_num ;
		u16				calllist4_num ;
	} MQO_MATERIAL_INFO;
	typedef struct {
		MQO_MATERIAL_INFO info ;
		u32				*calllist3 ;			// `pCallList
		u32				*calllist4 ;			// `pCallList
	} MQO_MATERIAL;
	typedef struct {
		char			objname[256];		// IuWFNgidlɕ̋KȂj
		bool			isVisible;			// 0F\@̑F\
		bool			isShadingFlat ;		// VF[fBO[h
		GLfloat minPoint[3];	// _ (x, y, z)
		GLfloat maxPoint[3];	// _ (x, y, z)
		int mat_num;
	} MQO_INNER_OBJECT_INFO;
	typedef struct {
		MQO_INNER_OBJECT_INFO info ;
		MQO_MATERIAL *mat ;
	} MQO_INNER_OBJECT;
	typedef struct {
		GLfloat minPoint[3];	// _ (x, y, z)
		GLfloat maxPoint[3];	// _ (x, y, z)
		char datafile[256] ;
		int obj_num ;
	} MQO_OBJECT_INFO;
	typedef struct {
		MQO_OBJECT_INFO info ;
		MQO_INNER_OBJECT *obj ;
	} MQO_OBJECT;
	typedef struct {
		GLfloat minPoint[3];	// _ (x, y, z)
		GLfloat maxPoint[3];	// _ (x, y, z)
		MQO_INNER_OBJECT *common_obj ;
		vector<MQO_OBJECT *>	model;		// f
	} MQO_SEQUENCE;
	bool static makeWorkFile(MQO_OBJECT *model) {
		FILE *fp ;
		fp = fopen(model->info.datafile,"w+b");
		if( fp == NULL ) return false;
		for( int i = 0 ; i < model->info.obj_num ; i++ ) {
			fwrite(&model->obj[i].info,sizeof(MQO_INNER_OBJECT_INFO),1,fp) ;
			for( int m = 0 ; m < model->obj[i].info.mat_num ; m++ ) {
				fwrite(&model->obj[i].mat[m].info,sizeof(MQO_MATERIAL_INFO),1,fp) ;
				if( 0 < model->obj[i].mat[m].info.calllist3_num ) {
					fwrite(model->obj[i].mat[m].calllist3,sizeof(u32)*model->obj[i].mat[m].info.calllist3_num,1,fp) ;
				}
				if( 0 < model->obj[i].mat[m].info.calllist4_num ) {
					fwrite(model->obj[i].mat[m].calllist4,sizeof(u32)*model->obj[i].mat[m].info.calllist4_num,1,fp) ;
				}
			}
		}
		
		fclose(fp) ;
		return true ;
	}
	void remakeObject(MQO_OBJECT *model) {
		if( m_seq.common_obj == NULL ) return ;
		FILE *fp ;
//		printf("load work file[%s]\n",model->info.datafile) ;
		fp = fopen(model->info.datafile,"rb");
		if( fp == NULL ) return ;
		for( int i = 0 ; i < model->info.obj_num ; i++ ) {
			fread(&model->obj[i].info,sizeof(MQO_INNER_OBJECT_INFO),1,fp) ;
			for( int m = 0 ; m < model->obj[i].info.mat_num ; m++ ) {
				fread(&model->obj[i].mat[m].info,sizeof(MQO_MATERIAL_INFO),1,fp) ;
				if( 0 < model->obj[i].mat[m].info.calllist3_num ) {
					fread(model->obj[i].mat[m].calllist3,sizeof(u32)*model->obj[i].mat[m].info.calllist3_num,1,fp) ;
				}
				if( 0 < model->obj[i].mat[m].info.calllist4_num ) {
					fread(model->obj[i].mat[m].calllist4,sizeof(u32)*model->obj[i].mat[m].info.calllist4_num,1,fp) ;
				}
			}
		}
		fclose(fp) ;
//printf("remakeObject 3\n") ;
		return ;
	}
	MQO_SEQUENCE m_seq ;
	cGLMetaseq(MQO_OBJECT *data) {
		m_seq.common_obj = NULL ;
		m_seq.minPoint[0] = data->info.minPoint[0] ;
		m_seq.minPoint[1] = data->info.minPoint[1] ;
		m_seq.minPoint[2] = data->info.minPoint[2] ;
		m_seq.maxPoint[0] = data->info.maxPoint[0] ;
		m_seq.maxPoint[1] = data->info.maxPoint[1] ;
		m_seq.maxPoint[2] = data->info.maxPoint[2] ;
		m_seq.model.push_back(data) ;
	}
	void push_back(MQO_OBJECT *data) {
		for( int xyz = 0 ; xyz < 3 ; xyz++ ) {
			if( data->info.minPoint[xyz] < m_seq.minPoint[xyz] ) 
				m_seq.minPoint[xyz] = data->info.minPoint[xyz] ;
			if( m_seq.maxPoint[xyz] < data->info.maxPoint[xyz] ) 
				m_seq.maxPoint[xyz] = data->info.maxPoint[xyz] ;
		}
		m_seq.model.push_back(data) ;
	}
public :
/*
	const vector<GLuint>& getTextures() {
		return m_texids ;
	}
	void swapTextures(GLuint after,GLuint before) {
		vector<GLuint>::iterator it;
		for( it = m_texids.begin(); it != m_texids.end(); it++ ){
			if( *it == before ) {
				m_texids.erase(it) ;
				m_texids.push_back(after) ;
				break ;
			}
		}
		vector<GLuint *>::iterator it2;
		for( it2 = m_texid_list.begin(); it2 != m_texid_list.end(); it2++ ){
			if( *(*it2) == before ) {
				*(*it2) = after ;
			}
		}
		size_t s,s_num ;
		size_t i,i_num ;
		size_t m,m_num ;
		MQO_OBJECT *obj ;
		MQO_INNER_OBJECT *inner ;
		vector<MQO_INNER_OBJECT *>::iterator inner_it ;
		vector<MQO_OBJECT *>::iterator obj_it ;
		s_num = m_seq.model.size() ;
		for( s = 0 ; s < s_num ; s++ ) {
			obj = m_seq.model.at(s) ;
			i_num = obj->obj.size() ;
			for( i = 0 ; i < i_num ; i++ ) {
				inner = obj->obj.at(i) ;
				m_num = inner->mat.size() ;
				for( m = 0 ; m < m_num ; m++ ) {
					MQO_MATERIAL &mat = inner->mat.at(m) ;
					if ( mat.isUseTexture) {	// eNX`ꍇ
						if( mat.texture_id == before ) {
							mat.texture_id = after ;
						}
					}
				}
			}
		}

	}
	*/
	virtual ~cGLMetaseq() {
		size_t s,s_num ;
		size_t i,i_num ;
		size_t m,m_num ;
		MQO_OBJECT *obj ;
		MQO_INNER_OBJECT *inner ;
		vector<MQO_INNER_OBJECT *>::iterator inner_it ;
		vector<MQO_OBJECT *>::iterator obj_it ;
		if( m_seq.common_obj != NULL ) {
			i_num = m_seq.model.at(0)->info.obj_num ;
			for( i = 0 ; i < i_num ; i++ ) {
				inner = &m_seq.model.at(0)->obj[i] ;
				m_num = inner->info.mat_num ;
				for( m = 0 ; m < m_num ; m++ ) {
					MQO_MATERIAL &mat = inner->mat[m] ;
					if( mat.calllist3 != NULL ) delete[] mat.calllist3 ;
					if( mat.calllist4 != NULL ) delete[] mat.calllist4 ;
				}
				delete[] inner->mat ;
			}
			s_num = m_seq.model.size() ;
			for( s = 0 ; s < s_num ; s++ ) {
				obj = m_seq.model.at(s) ;
				delete obj ;
			}
			return ;
		}
		s_num = m_seq.model.size() ;
		for( s = 0 ; s < s_num ; s++ ) {
			obj = m_seq.model.at(s) ;
			if( obj->obj != NULL ) {
				i_num = obj->info.obj_num ;
				for( i = 0 ; i < i_num ; i++ ) {
					inner = &obj->obj[i] ;
					m_num = inner->info.mat_num ;
	//printf("mat size = %d\n",m_num) ;
					for( m = 0 ; m < m_num ; m++ ) {
						MQO_MATERIAL &mat = inner->mat[m] ;
						if( mat.calllist3 != NULL ) delete[] mat.calllist3 ;
						if( mat.calllist4 != NULL ) delete[] mat.calllist4 ;
					}
					delete[] inner->mat ;
				}
				delete[] obj->obj ;
			}
			delete obj ;
		}
	}
public :
	//ǂݍ񂾃f[^̍ŏliAAjo
	// in frame  t[ԍ@ƑSt[̍ŏl
	// ߂l GLfloat[3]  0`Q@ꂼꂘAA
	const GLfloat *getMinPoint(int frame=-1) {
		if( frame < 0 ) {
			return m_seq.minPoint ;
		}
		if( frame < (int)m_seq.model.size() ) {
			return m_seq.model.at(frame)->info.minPoint ;
		}
		return NULL ;
	}
	//ǂݍ񂾃f[^̍őliAAjo
	// in frame  t[ԍ@ƑSt[̍ől
	// ߂l GLfloat[3]  0`Q@ꂼꂘAA
	const GLfloat *getMaxPoint(int frame=-1) {
		if( frame < 0 ) {
			return m_seq.maxPoint ;
		}
		if( frame < (int)m_seq.model.size() ) {
			return m_seq.model.at(frame)->info.maxPoint ;
		}
		return NULL ;
	}
	//ǂݍłt[o
	// ߂l@size_t t[
	size_t getFrameNum() {
		return m_seq.model.size() ;
	}
	void readyRender(int frame) {
		if( m_seq.model.size() <= (unsigned int)frame ) return ;
		MQO_OBJECT *sobj ;
		sobj = m_seq.model.at(frame) ;
		remakeObject(sobj) ;
	}
	//ǂݍł郂f̕`
	// in frame		`悷t[ԍiO`j
	// in alpha		xiOij`QTTj
	void render(int frame = 0) {
		if( m_seq.model.size() <= (unsigned int)frame ) return ;
		MQO_OBJECT *sobj ;
		MQO_INNER_OBJECT	*obj;
		size_t o,o_num ;
		size_t m,m_num ;

//printf("remakeObject before  frame[%d]\n",frame) ;
		sobj = m_seq.model.at(frame) ;
		glPushMatrix();
			glEnable(GL_ALPHA_TEST);

			o_num = sobj->info.obj_num ;
			for ( o=0; o<o_num; o++ ) {	// IuWFNg[v
				obj = &sobj->obj[o] ;
				m_num = obj->info.mat_num ;

				if ( ! obj->info.isVisible ) continue;
//				glShadeModel(((obj->isShadingFlat))?GL_FLAT:GL_SMOOTH) ;

				for ( m = 0; m < m_num; m++ ) {	//}eA[v
					MQO_MATERIAL &mat = obj->mat[m] ;

					if ( mat.calllist3 == NULL && mat.calllist4 == NULL ) continue;
					if ( mat.info.isValidMaterialInfo ) {	// }eȀݒ
						glMaterialf( GL_DIFFUSE, mat.info.difrgb);
						glMaterialf( GL_AMBIENT, mat.info.ambrgb);
						glMaterialf( GL_SPECULAR, mat.info.spcrgb);
						glMaterialf( GL_EMISSION, mat.info.emirgb);
						glMaterialf( GL_SHININESS, mat.info.powrgb);
					}
					if ( mat.info.isUseTexture) {	// eNX`ꍇ
						glEnable(GL_TEXTURE_2D);
//						glEnable(GL_BLEND);

						glBindTexture(0,mat.info.texture_id);
						if( mat.calllist3!= NULL ) glCallList(mat.calllist3) ;
						if( mat.calllist4!= NULL ) glCallList(mat.calllist4) ;
						glBindTexture(0,0);

					}
					else {	// eNX`Ȃꍇ

//						glDisable(GL_TEXTURE_2D);
//						glEnable(GL_BLEND);
						if( mat.calllist3!= NULL ) glCallList(mat.calllist3) ;
						if( mat.calllist4!= NULL ) glCallList(mat.calllist4) ;
					}
				}
			}

		glPopMatrix(1);
//printf("render path end\n") ;
	}
};

#include "cGLMetaseqParent_nds.h"
#endif
