#include <nds.h>
//#include "ini.h"
#include "cGLMetaseq_nds.h"
#include "ano.h"
#include "ano_sound.h"

float rotateX = 0.0;
float rotateY = 0.0;
float lookatX = 0.0 ;
float lookatY = 0.0 ;
float lookposX = 0.0 ;
float lookposY = 0.0 ;
float lookposZ = 9.0 ;

float obj_scale = 1.0 ;
float obj_posx = 0.0 ;
float obj_posy = 0.0 ;
float obj_posz = 0.0 ;
texturePool *texpool ;
cGLMetaseq *meta = NULL ;
cGLMetaseq *meta_step = NULL ;
bool meta_makeWork = false ;


float g_scale = 0.08 ;
#if DEF_EMU
char g_filename[256] = "Innocencer.mqo" ;
//char g_filename[256] = "InnocencerT.mqo" ;
//char g_filename[256] = "fat1:/test/data/miku_ano_play_0.mqo" ;
//char g_filename[256] = "mikuumauma_0.mqo" ;
//char g_filename[256] = "haku.mqo" ;
//char g_filename[256] = "miku_ano_play_10.mqo" ;
//char g_renbanfilehead[256] = "miku_ano_play_" ;
char g_renbanfilehead[256] = "cdefgab_" ;
char g_renbanfilehead_step[256] = "step_" ;
#else
//char g_filename[256] = "fat1:/test/data/Innocencer.mqo" ;
//char g_filename[256] = "fat1:/test/data/InnocencerT.mqo" ;
char g_filename[256] = "fat1:/ano/data/miku_ano_play_0.mqo" ;
//char g_renbanfilehead[256] = "fat1:/test/data/mikuumauma_" ;
//char g_renbanfilehead[256] = "fat1:/test/data/miku_ano_play_" ;
char g_renbanfilehead[256] = "fat1:/ano/data/cdefgab_" ;
char g_renbanfilehead_step[256] = "fat1:/ano/data/step_" ;
//char g_renbanfilehead[256] = "cdefgab_" ;
//char g_renbanfilehead_step[256] = "step_" ;
//char g_filename[256] = "fat1:/test/data/test.mqo" ;
#endif
// 3D\֌W̏
void init3D(bool alpha) {
	glInit() ;
// -----------------------------------------------------------------------------
// ̃e[uglInit()łONAĂȂۂ
// ꂪĂƃeNX`̓o^܂Ȃ
	gl_hidden_globals *hglobal = glGetGlobals() ;
/* 
printf("%d size = %d 0x%x\n",
hglobal->nameCount,
hglobal->texturePtrs.cur_size,
hglobal->nextBlock
) ;
for( int ddd = 0 ; ddd < hglobal->texturePtrs.cur_size ; ddd++ ) {
printf("dynamic 0x%x\n",DynamicArrayGet(&hglobal->texturePtrs,ddd)) ;
}
/* */
	for( int gpos = 0 ; gpos < hglobal->texturePtrs.cur_size ; gpos++ ) {
		DynamicArraySet(&hglobal->texturePtrs,gpos,(void *)0) ;
	//printf("dynamic 0x%x\n",DynamicArrayGet(&hglobal->texturePtrs,gpos)) ;
	}
// -----------------------------------------------------------------------------
	glEnable(GL_TEXTURE_2D) ;
	glEnable(GL_BLEND);
	glEnable(GL_ANTIALIAS) ;
	
	glClearColor(0,0,0,(alpha)?0:31) ;//obNɃrbg}bv`悷Ƃ͓߂ɂ
	glClearPolyID(63) ;
	glClearDepth(0x7FFF) ;
	
	glViewport(0,0,255,191) ;
	
	glMatrixMode(GL_PROJECTION) ;
	glLoadIdentity() ;
	gluPerspective(70,256.0/192.0, 0.1, 40) ;
	//(gluLookAt->videoGL.h)̂ȂGL_MODELVIEWɂčsĂ
	gluLookAt(	0.0, 0.0, 9.0,		//camera possition 
				0.0, 0.0, 0.0,		//look at
				0.0, 1.0, 0.0);		//up
	glMatrixMode(GL_MODELVIEW);
	glResetTextures() ;

	texpool = new texturePool(TEXTURE_SIZE_128) ;
	cGLMetaseqParent metap(texpool) ;
#if DEF_SEQ
		meta = metap.makeGLMetaseq(true,meta_makeWork,
				g_renbanfilehead,
				"%s%d.mqo",
				0, 6, 1,
				NULL,&g_scale) ;
		meta_step = metap.makeGLMetaseq(true,meta_makeWork,
				g_renbanfilehead_step,
				"%s%d.mqo",
				0, 3, 1,
				NULL,&g_scale) ;
#else
	meta = metap.makeGLMetaseq(true,g_filename,NULL,&g_scale) ;
#endif
}
size_t frame=0 ;
size_t nextFrame = 1;
size_t frameUp3D() {
	frame++ ;
	if( meta_step->getFrameNum() <= frame ) frame=0 ;
	return frame ;
}
const static double PI = 3.1415926535 ;
inline void turn(float s,float x0,float y0,float *x,float *y) {
	float r ;
	float orgx,orgy ;
	orgx = *x ;
	orgy = *y ;
	r = PI*(s)/180 ;
	*x = (orgx-x0)*cos(r) - (orgy-y0)*sin(r)+x0 ;
	*y = (orgx-x0)*sin(r) + (orgy-y0)*cos(r)+y0 ;
}
void view3DChange(u32 keys) {
	if( !((keys & KEY_R)
		||(keys & KEY_L)
		||(keys & KEY_A)
		||(keys & KEY_B)
		||(keys & KEY_X)
		||(keys & KEY_Y)
		||(keys & KEY_UP)
		||(keys & KEY_DOWN)
		||(keys & KEY_LEFT)
		||(keys & KEY_RIGHT)
						)) return ;
	if((keys & KEY_R)) {
		lookposZ+=0.1;
	}
	if((keys & KEY_L)) {
		lookposZ-=0.1;
	}
	if((keys & KEY_A)) {
		lookposX+=0.1;
	}
	if((keys & KEY_Y)) {
		lookposX-=0.1;
	}
	if((keys & KEY_X)) {
		lookposY+=0.1;
	}
	if((keys & KEY_B)) {
		lookposY-=0.1;
	}
	if((keys & KEY_UP)) lookatY += 0.1;
	if((keys & KEY_DOWN)) lookatY -= 0.1;
	if((keys & KEY_LEFT)) lookatX -= 0.1;
	if((keys & KEY_RIGHT)) lookatX += 0.1;
	//gluLookAt access GL_MODELVIEW -->videoGL.h
	//gluLookAtԂύXƂgluLookAtĂԑO
	//glMatrixMode(GL_MODELVIEW);glLoadIdentity();
	//ȂƂȂB
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity() ;

	glViewport(0,0,255,191) ;
	
	glMatrixMode(GL_PROJECTION) ;
	glLoadIdentity() ;
	gluPerspective(70,256.0/192.0, 0.1, 40) ;
	gluLookAt(	lookposX, lookposY, lookposZ,		//camera possition 
				lookatX, lookatY, 0.0,		//look at
				0.0, 1.0, 0.0);		//up
	iprintf("\x1b[7;0H");
	printf("lookpos  %.2f / %.2f / %.2f",(float)lookposX,(float)lookposY,(float)lookposZ) ;
	iprintf("\x1b[8;0H");
	printf("look at  %.2f / %.2f / %.2f",(float)lookatX,(float)lookatY,(float)0) ;
}
void obj3DChange(u32 keys) {
	if( !((keys & KEY_R)
		||(keys & KEY_L)
		||(keys & KEY_A)
		||(keys & KEY_B)
		||(keys & KEY_X)
		||(keys & KEY_Y)
		||(keys & KEY_UP)
		||(keys & KEY_DOWN)
		||(keys & KEY_LEFT)
		||(keys & KEY_RIGHT)
						)) return ;
	if((keys & KEY_R)) {
		obj_posy+=0.1;
	}
	if((keys & KEY_L)) {
		obj_posy-=0.1;
	}
	if((keys & KEY_A)) {
		obj_posx+=0.1;
	}
	if((keys & KEY_Y)) {
		obj_posx-=0.1;
	}
	if((keys & KEY_X)) {
		obj_posz+=0.1;
	}
	if((keys & KEY_B)) {
		obj_posz-=0.1;
	}
	if((keys & KEY_UP)) rotateX += 3;
	if((keys & KEY_DOWN)) rotateX -= 3;
	if((keys & KEY_LEFT)) rotateY -= 3;
	if((keys & KEY_RIGHT)) rotateY += 3;
	iprintf("\x1b[7;0H");
	printf("obj pos  %.2f / %.2f / %.2f",(float)obj_posx,(float)obj_posy,(float)obj_posz) ;
	iprintf("\x1b[8;0H");
	printf("rotate X %.2f Y %.2f ",(float)rotateX,(float)rotateY) ;
}
int syncs = 0 ;
u16 *image = NULL ;
int image_texsize = - 1;
int image_texsizePara = -1 ;
int image_texid = -1 ;
bool tgleTex = false ;
int newtex = - 1;
int nowttex = -1 ;
int nexttex = -1 ;
int beforePushNote = -1 ;
int noteAlive = -1 ;
size_t drow3D(int mode,uint32 keys[3],u16 *vram,int note) {
	// vsync̉񐔁ȉɔł񐔁jJE^Ƃ
	// eNX`̒ւEҋ@f̃t[؊^C~OɎgpĂB
	syncs++ ;
	syncs &=0x07 ;
	//vC[h̎AL[͂ŃTuʂeNX`ƂĎ荞ނǂ̃gKon/off
	if( mode == enum_play ) {
		if((keys[0] & KEY_X)) tgleTex = !tgleTex ;
	}

	if( mode == enum_play ) {
		iprintf("\x1b[1;16Hcopy[x] %s  ",(tgleTex)?"On ":"Off") ;
	}
	// TuʂeNX`ƂĎ荞
	if( tgleTex ) {
//	int texid ;
		if( image == NULL ) { //ŏ@eNX`쐬pobt@쐬
			image_texid   = texpool->get(2) ;	//(R)Ԗڂ̃eNX`؂ւ
												//zg͌ߑłȂĂǂ灛Ԗڂď񂪂قc
			image_texsize = texpool->getSize(image_texid) ;
			image_texsizePara = texpool->getParamSize(image_texsize) ;
			image = new u16[image_texsize*image_texsize] ;
		}
		if( 0 < image_texid && syncs== 1) {
		/* */
//			image = new u16[texsize*texsize] ;
			memset(image,0,image_texsize*image_texsize*sizeof(u16)) ;
			int xs,xe,ys,ye ;
			int vx,vy ;
			if( 256 <= image_texsize ) {
				ys = (image_texsize-192)/2 ;
				ye = image_texsize-((image_texsize-192)/2) ;
				xs = (image_texsize-256)/2 ;
				xe = image_texsize-((image_texsize-256)/2) ;
				vy = 0 ;
			for( int y = ys ; y < (ys+192) ; y++ ) {
					memcpy(&image[y*image_texsize+xs],&vram[vy*256],192*sizeof(u16)) ;
					vy++ ;
				}
			}
			if( image_texsize < 256 ) {
				int add ;
				add = 256 / image_texsize ;
				vy = 0 ;
				for( int y = 0 ; y < image_texsize ; y++ ) {
					vx = 0 ;
					for( int x = 0 ; x < image_texsize ; x++ ) {
						image[y*image_texsize+x] = vram[vy*256+vx] ;
						vx+=add ;
					}
					vy+=add ;
				}
			}
			glBindTexture(0,image_texid);	// eNX`̊蓖
			glTexImage2D(0, 0, GL_RGBA, image_texsizePara, image_texsizePara,
							0,  TEXGEN_TEXCOORD, (u8*)image);
//		delete[] image ;
		}
#if 0
	{
		void *buf = glGetTexturePointer(texid) ;
		printf("tex pointer %04x", (char *)buf);
	}
#endif
	}
//	if( syncs & 0x01 ) return 0 ;
	size_t drowframe;
	drowframe = frame ;


	//J؊[h̎̓Jړ
	if( mode == enum_camera ) {
		view3DChange(keys[2]) ;
	}

	glPushMatrix();
	//IuWFNgړ[h͈̎ړ
	if( mode == enum_obj ) {
		obj3DChange(keys[2]) ;
	}
	glRotateX(rotateX);
	glRotateY(rotateY);
	glTranslatef(obj_posx,obj_posy,obj_posz) ;
	glScalef(obj_scale,obj_scale,obj_scale) ;
	
	glMatrixMode(GL_MODELVIEW);
	//not a real gl function and will likely change
	glPolyFmt(POLY_ALPHA(31) | POLY_CULL_BACK 
		| POLY_FORMAT_LIGHT0 //| POLY_FORMAT_LIGHT1 
//		| POLY_FORMAT_LIGHT2 | POLY_FORMAT_LIGHT3 
		) ;
	glLight(0, RGB15(31,31,31) , 0,				  floattov10(-1.0),		 0);
/*
	glLight(0, RGB15(31,31,31) , 0,				  floattov10(-1.0),		 0);
	glLight(1, RGB15(31,0,31),   0,				  floattov10(1) - 1,			 0);
	glLight(2, RGB15(0,31,0) ,   floattov10(-1.0), 0,					 0);
	glLight(3, RGB15(0,0,31) ,   floattov10(1.0) - 1,  0,					 0);
 */


//	printf("                  render start\n") ;
	//draw the obj
	if( -1 == note && noteAlive != -1 ) {
		// ̊y퉉t̃f vsync̎inoteAlivej̃f\
		// ^b`y𗣂uԂɃf؂ւ̂h~
		drowframe = (beforePushNote & DEF_NOTE_NUM)%7 ;
		noteAlive-- ;
		if( meta != NULL ) {
			meta->render(drowframe) ;
		}
	}
	else if( -1 != note ) {
		// ̊y퉉t̃f
		beforePushNote = note ;
		noteAlive = 15 ;
		drowframe = (note & DEF_NOTE_NUM)%7 ;
		if( meta != NULL ) {
			meta->render(drowframe) ;
		}
	}
	else {
		// ̊ytĂȂƂ̃f
		if( meta_step != NULL ) {
			meta_step->render(drowframe) ;
		}
	}

	glPopMatrix(1);
	glFlush(GL_WBUFFERING);

	if(syncs == 0 ) {
		nextFrame = frameUp3D() ;
	}
	if( meta_makeWork && syncs == 2) {
		meta->readyRender(nextFrame) ;
	}
//	printf("              frame[%d]\n",drowframe) ;
	return drowframe;
}
void info3D() {
	if( meta != NULL ) {
		const GLfloat *max,*min ;
		max = meta->getMaxPoint() ;
		iprintf("\x1b[6;0Hmax[%d   %d   %d]    \n",(int)max[0],(int)max[1],(int)max[2]);
		min = meta->getMinPoint() ;
		iprintf("\x1b[7;0Hmin[%d   %d   %d]    \n",(int)min[0],(int)min[1],(int)min[2]);
	}
	iprintf("\x1b[11;0Hlookpos = [%d][%d][%d]        \n",
			(int)lookposX,(int)lookposY,(int)lookposZ);
	iprintf("\x1b[12;0Hrotate = [%d, %d]          \n", (int)rotateX, (int)rotateY);
}
