#include <nds.h>
#include <stdio.h>

#include "ano_draw.h"
#include "ano_sound.h"
#define DEF_ITEMS 10

//std::list<STR_DRAW> dlist ;
STR_DRAW  dlist[DEF_ITEMS] ;
int	dlist_pos = 0;
int	dlist_num = 0;
int modes = 0 ;
int nownote = -1 ;
void drawInit() {
	for( int d = 0 ; d < DEF_ITEMS ; d++ ) {
		dlist[d].mode = -1 ;
		dlist[d].alives = 0 ;
	}
}
void drawSubLine(disp2D_BMP16 &disp,int *xpos,int *ypos,int xnum,int ynum) {
	for( int x = 1 ; x < xnum ; x++ ) {
		disp.line(xpos[x],0,xpos[x],192,ARGB16(1,0,15,20)) ;
	}
	for( int y = 1 ; y < ynum ; y++ ) {
		disp.line(0,ypos[y],256,ypos[y],ARGB16(1,0,15,20)) ;
	}
}
void pointDraw(int x,int y,disp2D_BMP16 &disp,uint32 keys[3],int note,bool isPaint) {
//	STR_DRAW dd ;
		modes ++ ;
		modes &= 0x03 ;
//	if( (modes) == 0 ) disp.alphaBack() ;
//	if( (modes) == 0 ) disp.clearBack(ARGB16(1,0,0,0)) ;

	if( (keys[2] & KEY_TOUCH) &&
		(note&DEF_NOTE_NUM) != DEF_NOTE_NUM) {
		int x0,y0 ;
		int x1,y1 ;
		int s = 30+y/10 ;
		for( int i = 0 ;i < 2 ; i++ ){
			s = s+i*(90+x/10) ;
			x0 = 256-x ;
			y0 = y-tan(disp2D::radian(s))*x0 ;
			x0 = 256 ;
			x1 = 0 ;
			y1 = y+tan(disp2D::radian(s))*x ;
			disp.line(x0,y0,x1,y1,
							ARGB16(1,0,31,0),4) ;
		}
	}
	if( x != 0 && y != 0 &&
		( nownote != note ) | (keys[0] & KEY_TOUCH)) {
//		printf("\n note = 0x%x      ",note) ;
		nownote = note ;
		dlist_pos++ ;
		dlist_num += 1;
		if( (DEF_ITEMS-1) < dlist_pos ) dlist_pos = 0 ;
		if( DEF_ITEMS < dlist_num ) dlist_num = DEF_ITEMS ;
//	iprintf("\x1b[12;0H  draw num[%d]",dlist_num) ;
		dlist[dlist_pos].alives =  0;
//		if( keys[0] & KEY_TOUCH ) dlist[dlist_pos].mode = 2 ;
//		if( keys[1] & KEY_TOUCH ) dlist[dlist_pos].mode = 0 ;
		dlist[dlist_pos].mode = modes ;
		dlist[dlist_pos].x = x ;
		dlist[dlist_pos].y = y ;
		dlist[dlist_pos].color[0] = 0 ;
		dlist[dlist_pos].color[1] = 31 ;
		dlist[dlist_pos].color[2] = 0 ;
	/* 
		int bx0,bx1,by0,by1 ;
		bx0 = x-50 ;
		bx1 = x+50 ;
		by0 = y-50 ;
		by1 = y+50 ;
		disp.box(bx0,by0,bx1,by1,RGB15(31,12,0)|0x8000,4) ;
		 */
		/* 
		dd.alives =  0;
		dd.mode = 0 ;
		dd.x = x ;
		dd.y = y ;
		dd.color[0] = 0 ;
		dd.color[1] = 31 ;
		dd.color[2] = 0 ;
		dlist.push_back(dd) ;
		 */
	}
	if( 0 < dlist_num && isPaint ) {
//	iprintf("\x1b[13;0H  draw num[%d]",dlist_num) ;
//		int bx0,bx1,by0,by1;
		int lx0,lx1,lx2,ly0,ly1,ly2,lx3,ly3,r ;
		for( int d = 0 ; d < DEF_ITEMS ; d++ ) {
			switch(dlist[d].mode) {
			case 0:
			case 3:
		lx0 = dlist[d].x-20 -(dlist[d].alives*7) ;
		ly0 = dlist[d].y-20 -(dlist[d].alives*7) ;
		lx1 = dlist[d].x-20 -(dlist[d].alives*7) ;
		ly1 = dlist[d].y+20 +(dlist[d].alives*7) ;
		lx2 = dlist[d].x+20 +(dlist[d].alives*7) ;
		ly2 = dlist[d].y+20 +(dlist[d].alives*7) ;
		lx3 = dlist[d].x+20 +(dlist[d].alives*7) ;
		ly3 = dlist[d].y-20 -(dlist[d].alives*7) ;
		disp.turn(dlist[d].alives*25-(dlist[d].alives*2),dlist[d].x,dlist[d].y,&lx0,&ly0) ;
		disp.turn(dlist[d].alives*25-(dlist[d].alives*2),dlist[d].x,dlist[d].y,&lx1,&ly1) ;
		disp.turn(dlist[d].alives*25-(dlist[d].alives*2),dlist[d].x,dlist[d].y,&lx2,&ly2) ;
		disp.turn(dlist[d].alives*25-(dlist[d].alives*2),dlist[d].x,dlist[d].y,&lx3,&ly3) ;
		if( dlist[d].alives < 12 ) {
			disp.line(lx0,ly0,lx1,ly1,
							ARGB16(1,dlist[d].color[0],dlist[d].color[1],dlist[d].color[2]),4) ;
			disp.line(lx1,ly1,lx2,ly2,
							ARGB16(1,dlist[d].color[0],dlist[d].color[1],dlist[d].color[2]),4) ;
			disp.line(lx2,ly2,lx3,ly3,
							ARGB16(1,dlist[d].color[0],dlist[d].color[1],dlist[d].color[2]),4) ;
			disp.line(lx3,ly3,lx0,ly0,
							ARGB16(1,dlist[d].color[0],dlist[d].color[1],dlist[d].color[2]),4) ;
			dlist[d].alives++ ;
		}
		else {
			dlist[d].mode = -1 ;
			dlist_num-- ;
		}
				break ;
				/*
			case 0:
		bx0 = dlist[d].x-30 -(dlist[d].alives*10) ;
		bx1 = dlist[d].x+30 +(dlist[d].alives*10) ;
		by0 = dlist[d].y-30 -(dlist[d].alives*10) ;
		by1 = dlist[d].y+30 +(dlist[d].alives*10) ;
//		dlist[d].color[1] -= (dlist[d].alives*5) ;
//		if( 5 <  dlist[d].color[1] ) {
		if( dlist[d].alives < 10 ) {
//		printf(" %d %d %d %d\n",bx0,by0,bx1,by1) ;
			disp.box(bx0,by0,bx1,by1,
						ARGB16(1,dlist[d].color[0],dlist[d].color[1],dlist[d].color[2]),4) ;
			dlist[d].alives++ ;
		}
		else {
			dlist[d].mode = -1 ;
			dlist_num-- ;
		}
				break ; */
			case 1:
		lx0 = dlist[d].x ;
		ly0 = dlist[d].y-20 -(dlist[d].alives*8) ;
		lx1 = dlist[d].x-17 -(dlist[d].alives*6) ;
		ly1 = dlist[d].y+11 +(dlist[d].alives*3) ;
		lx2 = dlist[d].x+17 +(dlist[d].alives*6)-4 ;
		ly2 = dlist[d].y+11 +(dlist[d].alives*3) ;
		disp.turn(dlist[d].alives*25-(dlist[d].alives*2),dlist[d].x,dlist[d].y,&lx0,&ly0) ;
		disp.turn(dlist[d].alives*25-(dlist[d].alives*2),dlist[d].x,dlist[d].y,&lx1,&ly1) ;
		disp.turn(dlist[d].alives*25-(dlist[d].alives*2),dlist[d].x,dlist[d].y,&lx2,&ly2) ;
		if( dlist[d].alives < 12 ) {
			disp.line(lx0,ly0,lx1,ly1,
							ARGB16(1,dlist[d].color[0],dlist[d].color[1],dlist[d].color[2]),4) ;
			disp.line(lx1,ly1,lx2,ly2,
							ARGB16(1,dlist[d].color[0],dlist[d].color[1],dlist[d].color[2]),4) ;
			disp.line(lx2,ly2,lx0,ly0,
							ARGB16(1,dlist[d].color[0],dlist[d].color[1],dlist[d].color[2]),4) ;
			dlist[d].alives++ ;
		}
		else {
			dlist[d].mode = -1 ;
			dlist_num-- ;
		}
				break ;
			case 2 :
		r = 25+dlist[d].alives*9 ;
		if( dlist[d].alives < 12 ) {
			disp.circle(dlist[d].x,dlist[d].y,r,
							ARGB16(1,dlist[d].color[0],dlist[d].color[1],dlist[d].color[2]),4) ;
			dlist[d].alives++ ;
		}
		else {
			dlist[d].mode = -1 ;
			dlist_num-- ;
		}
				break ;
			}
		}
	}
	/*
	if( dlist.size() != 0 ) {
		int bx0,bx1,by0,by1 ;
		std::list<STR_DRAW>::iterator it ;
		int delnum = 0;
		for( it = dlist.begin() ; it != dlist.end() ; ) {
			switch(it->mode) {
			case 0:
		bx0 = x-30 -(it->alives*10) ;
		bx1 = x+30 +(it->alives*10) ;
		by0 = y-30 -(it->alives*10) ;
		by1 = y+30 +(it->alives*10) ;
		it->color[1] -= (it->alives*5) ;
		if( 5 <  it->color[1] && it->alives < 2 ) {
			disp.box(bx0,by0,bx1,by1,
						RGB15(it->color[0],it->color[1],it->color[2])|0x8000,4) ;
			it->alives++ ;
			it++ ;
		}
		else {
			it = dlist.erase(it) ;
		}
				break ;
			}
		}
//		disp.flushBack() ;
	}
	 */
}
